// Cette dmo ets un prtexte 
//
// - prsenter les nouveux rpertories des librairies
// - indiquer comme compiler une application avec les nouvelles API
// - utiliser la SDK Windows 7, les en-ttes, les .lib, etc (configurer dans le soptions gnrales de Visual
// - travailler avec les pointeurs intelligents
// Comment trouver le CLSID, soit dans les en-ttes, soit ailleurs, mais pour l'instant on ne sait pas o
// pourquoi pas dans la base de registre

// Notes:
// CLSID_FileDialog2 n'existe pas.
// On obtient un pointeur sur elle avec une ouverture de FileOpenDialog ou FileSaveDialog
// DemoIFileDialog2.cpp : Defines the entry point for the console application.
//
// CLSCTX_INPROC_SERVER fonctionne, mais pas CLSCTX_LOCAL_SERVER
//
// ATTENTION Show ne retourne pas S_OK Si l'utilisateur clique sur Cancel 

#include <iostream>
using namespace std;

#include <COMUtils.h>
#include <shobjidl.h>


int main(int argc, char* argv[])
{
	try
	{
		COMInitializer ci;
		HRESULT hr;
		SmartCOMPtr<IFileDialog2> fd;

		// Crer indirectement une instance COM de IFileDialog2
		hr = ::CoCreateInstance(CLSID_FileOpenDialog,
                          NULL,
                          CLSCTX_INPROC_SERVER,
                          IID_IFileDialog2,
                          (void **)&fd);
		COMHelper::TestOk(hr);
		fd->Show(0);
	}
	catch(COMException ce)
	{
		std::cout << ce.raison() << std::endl;
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}


