// DemoLibraryManagementDialog.cpp : Defines the entry point for the console application.
//

#include <iostream>
using namespace std;

#include <COMUtils.h>
#include <shobjidl.h>
#include <shlobj.h>
#include <Knownfolders.h>

int main(int argc, char* argv[])
{
	try
	{
		COMInitializer ci;
		HRESULT hr;
		WCHAR* instruction = L"Programmez! Abonnez vous ! ;-)";
		SmartCOMPtr<IShellItem> item;

		hr = ::SHGetKnownFolderItem(FOLDERID_DocumentsLibrary,
			KF_FLAG_DEFAULT_PATH, 
			0,
			IID_IShellItem,
			reinterpret_cast<void **>(&item));
		COMHelper::TestOk(hr);

		hr = SHShowManageLibraryUI(
			&(*item),
			NULL, 
			NULL,
			instruction,
			LMD_ALLOWUNINDEXABLENETWORKLOCATIONS);  
	}
	catch(COMException ce)
	{
		std::cout << ce.raison() << std::endl;
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}